/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _CELLPHONENUMBER_H_
#define _CELLPHONENUMBER_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class VoicePhoneNumber;
    class MessagingNumber;

}

#include "voicephonenumber.h"

namespace NepomukFast {

    /**
     * A cellular phone number. Inspired by the (TYPE=cell) parameter 
     * of the TEL property as defined in RFC 2426 sec 3.3.1. Usually 
     * a cellular phone can accept voice calls as well as textual messages 
     * (SMS), therefore this class has two superclasses. 
     */
    class CellPhoneNumber : public VoicePhoneNumber
    {
    public:
        /**
         * Create a new empty and invalid CellPhoneNumber instance
         */
        CellPhoneNumber( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        MessagingNumber toMessagingNumber() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        VoicePhoneNumber toVoicePhoneNumber() const;



    protected:
        CellPhoneNumber( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
