/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _RECURRENCEIDENTIFIER_H_
#define _RECURRENCEIDENTIFIER_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class UnionOfEventJournalTimezoneTodo;
    class NcalDateTime;
    class RecurrenceIdentifierRange;

}

#include "resource.h"

namespace NepomukFast {

    /**
     * Recurrence Identifier. Introduced to provide a structure 
     * for the value of ncal:recurrenceId property. See the documentation 
     * of ncal:recurrenceId for details. 
     */
    class RecurrenceIdentifier : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid RecurrenceIdentifier instance
         */
        RecurrenceIdentifier( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'range'. To specify the effective range of recurrence 
         * instances from the instance specified by the recurrence identifier 
         * specified by the property. It is intended to express the RANGE 
         * parameter specified in RFC 2445 sec. 4.2.13. The set of possible 
         * values for this property is limited. See also the documentation 
         * for ncal:recurrenceId for more details. 
         */
        void setRanges( const QList<RecurrenceIdentifierRange>& value );

        /**
         * Add a value to property 'range'. To specify the effective range 
         * of recurrence instances from the instance specified by the 
         * recurrence identifier specified by the property. It is intended 
         * to express the RANGE parameter specified in RFC 2445 sec. 4.2.13. 
         * The set of possible values for this property is limited. See 
         * also the documentation for ncal:recurrenceId for more details. 
         */
        void addRange( const RecurrenceIdentifierRange& value );

        /**
         * Set property 'range'. To specify the effective range of recurrence 
         * instances from the instance specified by the recurrence identifier 
         * specified by the property. It is intended to express the RANGE 
         * parameter specified in RFC 2445 sec. 4.2.13. The set of possible 
         * values for this property is limited. See also the documentation 
         * for ncal:recurrenceId for more details. 
         */
        void setRange( const RecurrenceIdentifierRange& value );

        /**
         * \return The URI of the property 'range'. 
         */
        static QUrl rangeUri();

        /**
         * Set property 'recurrenceIdDateTime'. The date and time of 
         * a recurrence identifier. Provided to express the actual value 
         * of the ncal:recurrenceId property. See documentation for 
         * ncal:recurrenceId for details. 
         */
        void setRecurrenceIdDateTimes( const QList<NcalDateTime>& value );

        /**
         * Add a value to property 'recurrenceIdDateTime'. The date and 
         * time of a recurrence identifier. Provided to express the actual 
         * value of the ncal:recurrenceId property. See documentation 
         * for ncal:recurrenceId for details. 
         */
        void addRecurrenceIdDateTime( const NcalDateTime& value );

        /**
         * Set property 'recurrenceIdDateTime'. The date and time of 
         * a recurrence identifier. Provided to express the actual value 
         * of the ncal:recurrenceId property. See documentation for 
         * ncal:recurrenceId for details. 
         */
        void setRecurrenceIdDateTime( const NcalDateTime& value );

        /**
         * \return The URI of the property 'recurrenceIdDateTime'. 
         */
        static QUrl recurrenceIdDateTimeUri();



    protected:
        RecurrenceIdentifier( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
