/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "role.h"

#include "postaladdress.h"
#include "contactmedium.h"
#include "emailaddress.h"
#include "phonenumber.h"
#include "imaccount.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::Role::Role( const QUrl &uri, const QUrl &graphUri )
  : NepomukFast::Resource( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#Role", QUrl::StrictMode) )
{
}

NepomukFast::Role::Role( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : NepomukFast::Resource( uri, graphUri, type )
{
}

void NepomukFast::Role::setUrls( const QList<NepomukFast::Resource>& value )
{
    for( QList<Resource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#url"), (*it).uri() );
    }
}

void NepomukFast::Role::addUrl( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#url"), value.uri() );
}

QUrl NepomukFast::Role::urlUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#url");
}

void NepomukFast::Role::setIMAccounts( const QList<NepomukFast::IMAccount>& value )
{
    for( QList<IMAccount>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasIMAccount"), (*it).uri() );
    }
}

void NepomukFast::Role::addIMAccount( const NepomukFast::IMAccount& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasIMAccount"), value.uri() );
}

QUrl NepomukFast::Role::iMAccountUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasIMAccount");
}

void NepomukFast::Role::setPhoneNumbers( const QList<NepomukFast::PhoneNumber>& value )
{
    for( QList<PhoneNumber>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasPhoneNumber"), (*it).uri() );
    }
}

void NepomukFast::Role::addPhoneNumber( const NepomukFast::PhoneNumber& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasPhoneNumber"), value.uri() );
}

QUrl NepomukFast::Role::phoneNumberUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasPhoneNumber");
}

void NepomukFast::Role::setWebsiteUrls( const QList<NepomukFast::Resource>& value )
{
    for( QList<Resource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#websiteUrl"), (*it).uri() );
    }
}

void NepomukFast::Role::addWebsiteUrl( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#websiteUrl"), value.uri() );
}

QUrl NepomukFast::Role::websiteUrlUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#websiteUrl");
}

void NepomukFast::Role::setEmailAddresses( const QList<NepomukFast::EmailAddress>& value )
{
    for( QList<EmailAddress>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasEmailAddress"), (*it).uri() );
    }
}

void NepomukFast::Role::addEmailAddress( const NepomukFast::EmailAddress& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasEmailAddress"), value.uri() );
}

QUrl NepomukFast::Role::emailAddressUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasEmailAddress");
}

void NepomukFast::Role::setContactMediums( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasContactMedium"), (*it).uri() );
    }
}

void NepomukFast::Role::addContactMedium( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasContactMedium"), value.uri() );
}

QUrl NepomukFast::Role::contactMediumUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasContactMedium");
}

void NepomukFast::Role::setFoafUrls( const QList<NepomukFast::Resource>& value )
{
    for( QList<Resource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#foafUrl"), (*it).uri() );
    }
}

void NepomukFast::Role::addFoafUrl( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#foafUrl"), value.uri() );
}

QUrl NepomukFast::Role::foafUrlUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#foafUrl");
}

void NepomukFast::Role::setBlogUrls( const QList<NepomukFast::Resource>& value )
{
    for( QList<Resource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#blogUrl"), (*it).uri() );
    }
}

void NepomukFast::Role::addBlogUrl( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#blogUrl"), value.uri() );
}

QUrl NepomukFast::Role::blogUrlUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#blogUrl");
}

void NepomukFast::Role::setPostalAddresses( const QList<NepomukFast::PostalAddress>& value )
{
    for( QList<PostalAddress>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasPostalAddress"), (*it).uri() );
    }
}

void NepomukFast::Role::addPostalAddress( const NepomukFast::PostalAddress& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasPostalAddress"), value.uri() );
}

QUrl NepomukFast::Role::postalAddressUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasPostalAddress");
}

void NepomukFast::Role::setStarts( const QList<QDateTime>& value )
{
    for( QList<QDateTime>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#start"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Role::addStart( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#start"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Role::setStart( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#start"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Role::startUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#start");
}

void NepomukFast::Role::setEnds( const QList<QDateTime>& value )
{
    for( QList<QDateTime>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#end"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Role::addEnd( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#end"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Role::setEnd( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#end"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Role::endUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#end");
}


