/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _TODO_H_
#define _TODO_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class UnionOfEventTodo;
    class UnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo;
    class InformationElement;
    class UnionOfEventJournalTodo;
    class UnionOfTimezoneObservanceEventJournalTimezoneTodo;
    class UnionOfAlarmEventTodo;
    class UnionOfAlarmEventFreebusyJournalTodo;
    class UnionOfEventFreebusyJournalTodo;
    class TodoStatus;
    class UnionOfTimezoneObservanceEventFreebusyTimezoneTodo;
    class UnionOfAlarmEventFreebusyTodo;
    class UnionOfAlarmEventJournalTodo;
    class UnionOfEventJournalTimezoneTodo;
    class NcalDateTime;

}

#include "unionofeventjournaltodo.h"

namespace NepomukFast {

    /**
     * Provide a grouping of calendar properties that describe a to-do. 
     */
    class Todo : public UnionOfEventJournalTodo
    {
    public:
        /**
         * Create a new empty and invalid Todo instance
         */
        Todo( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'percentComplete'. This property is used by an 
         * assignee or delegatee of a to-do to convey the percent completion 
         * of a to-do to the Organizer. Inspired by RFC 2445 sec. 4.8.1.8 
         */
        void setPercentCompletes( const QList<qint64>& value );

        /**
         * Add a value to property 'percentComplete'. This property is 
         * used by an assignee or delegatee of a to-do to convey the percent 
         * completion of a to-do to the Organizer. Inspired by RFC 2445 
         * sec. 4.8.1.8 
         */
        void addPercentComplete( const qint64& value );

        /**
         * \return The URI of the property 'percentComplete'. 
         */
        static QUrl percentCompleteUri();

        /**
         * Set property 'completed'. This property defines the date and 
         * time that a to-do was actually completed. Inspired by RFC 2445 
         * sec. 4.8.2.1. Note that the RFC allows ONLY UTC time values for 
         * this property. 
         */
        void setCompleteds( const QList<QDateTime>& value );

        /**
         * Add a value to property 'completed'. This property defines 
         * the date and time that a to-do was actually completed. Inspired 
         * by RFC 2445 sec. 4.8.2.1. Note that the RFC allows ONLY UTC time 
         * values for this property. 
         */
        void addCompleted( const QDateTime& value );

        /**
         * Set property 'completed'. This property defines the date and 
         * time that a to-do was actually completed. Inspired by RFC 2445 
         * sec. 4.8.2.1. Note that the RFC allows ONLY UTC time values for 
         * this property. 
         */
        void setCompleted( const QDateTime& value );

        /**
         * \return The URI of the property 'completed'. 
         */
        static QUrl completedUri();

        /**
         * Set property 'todoStatus'. Defines the overall status or confirmation 
         * for a todo. Based on the STATUS property defined in RFC 2445 sec. 
         * 4.8.1.11. 
         */
        void setTodoStatuses( const QList<TodoStatus>& value );

        /**
         * Add a value to property 'todoStatus'. Defines the overall status 
         * or confirmation for a todo. Based on the STATUS property defined 
         * in RFC 2445 sec. 4.8.1.11. 
         */
        void addTodoStatus( const TodoStatus& value );

        /**
         * Set property 'todoStatus'. Defines the overall status or confirmation 
         * for a todo. Based on the STATUS property defined in RFC 2445 sec. 
         * 4.8.1.11. 
         */
        void setTodoStatus( const TodoStatus& value );

        /**
         * \return The URI of the property 'todoStatus'. 
         */
        static QUrl todoStatusUri();

        /**
         * Set property 'due'. This property defines the date and time 
         * that a to-do is expected to be completed. Inspired by RFC 2445 
         * sec. 4.8.2.3 
         */
        void setDues( const QList<NcalDateTime>& value );

        /**
         * Add a value to property 'due'. This property defines the date 
         * and time that a to-do is expected to be completed. Inspired by 
         * RFC 2445 sec. 4.8.2.3 
         */
        void addDue( const NcalDateTime& value );

        /**
         * Set property 'due'. This property defines the date and time 
         * that a to-do is expected to be completed. Inspired by RFC 2445 
         * sec. 4.8.2.3 
         */
        void setDue( const NcalDateTime& value );

        /**
         * \return The URI of the property 'due'. 
         */
        static QUrl dueUri();

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventJournalTimezoneTodo toUnionOfTimezoneObservanceEventJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventFreebusyTimezoneTodo toUnionOfTimezoneObservanceEventFreebusyTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventFreebusyJournalTodo toUnionOfAlarmEventFreebusyJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventJournalTimezoneTodo toUnionOfEventJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo toUnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventJournalTodo toUnionOfAlarmEventJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventFreebusyTodo toUnionOfAlarmEventFreebusyTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventTodo toUnionOfEventTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventFreebusyJournalTodo toUnionOfEventFreebusyJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        InformationElement toInformationElement() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventTodo toUnionOfAlarmEventTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventJournalTodo toUnionOfEventJournalTodo() const;



    protected:
        Todo( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
