/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _UNIONOFEVENTTODO_H_
#define _UNIONOFEVENTTODO_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class CalendarDataObject;
    class Resource;

}

#include "unionparentclass.h"

namespace NepomukFast {


    class UnionOfEventTodo : public UnionParentClass
    {
    public:
        /**
         * Create a new empty and invalid UnionOfEventTodo instance
         */
        UnionOfEventTodo( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'geo'. This property specifies information related 
         * to the global position for the activity specified by a calendar 
         * component. Inspired by RFC 2445 sec. 4.8.1.6 
         */
        void setGeos( const QList<Resource>& value );

        /**
         * Add a value to property 'geo'. This property specifies information 
         * related to the global position for the activity specified by 
         * a calendar component. Inspired by RFC 2445 sec. 4.8.1.6 
         */
        void addGeo( const Resource& value );

        /**
         * Set property 'geo'. This property specifies information related 
         * to the global position for the activity specified by a calendar 
         * component. Inspired by RFC 2445 sec. 4.8.1.6 
         */
        void setGeo( const Resource& value );

        /**
         * \return The URI of the property 'geo'. 
         */
        static QUrl geoUri();

        /**
         * Set property 'priority'. The property defines the relative 
         * priority for a calendar component. Inspired by RFC 2445 sec. 
         * 4.8.1.9 
         */
        void setPrioritys( const QList<qint64>& value );

        /**
         * Add a value to property 'priority'. The property defines the 
         * relative priority for a calendar component. Inspired by RFC 
         * 2445 sec. 4.8.1.9 
         */
        void addPriority( const qint64& value );

        /**
         * Set property 'priority'. The property defines the relative 
         * priority for a calendar component. Inspired by RFC 2445 sec. 
         * 4.8.1.9 
         */
        void setPriority( const qint64& value );

        /**
         * \return The URI of the property 'priority'. 
         */
        static QUrl priorityUri();

        /**
         * Set property 'resources'. Defines the equipment or resources 
         * anticipated for an activity specified by a calendar entity. 
         * Inspired by RFC 2445 sec. 4.8.1.10 with the following reservations: 
         * the LANGUAGE parameter has been discarded. Please use xml:lang 
         * literals to express language. For the ALTREP parameter use 
         * the resourcesAltRep property. This property specifies multiple 
         * resources. The order is not important. it is recommended to 
         * introduce a separate triple for each resource. 
         */
        void setResourceses( const QStringList& value );

        /**
         * Add a value to property 'resources'. Defines the equipment 
         * or resources anticipated for an activity specified by a calendar 
         * entity. Inspired by RFC 2445 sec. 4.8.1.10 with the following 
         * reservations: the LANGUAGE parameter has been discarded. 
         * Please use xml:lang literals to express language. For the ALTREP 
         * parameter use the resourcesAltRep property. This property 
         * specifies multiple resources. The order is not important. 
         * it is recommended to introduce a separate triple for each resource. 
         */
        void addResources( const QString& value );

        /**
         * \return The URI of the property 'resources'. 
         */
        static QUrl resourcesUri();

        /**
         * Set property 'location'. Defines the intended venue for the 
         * activity defined by a calendar component. Inspired by RFC 2445 
         * sec 4.8.1.7 with the following reservations: the LANGUAGE 
         * parameter has been discarded. Please use xml:lang literals 
         * to express language. For the ALTREP parameter use the locationAltRep 
         * property. 
         */
        void setLocations( const QStringList& value );

        /**
         * Add a value to property 'location'. Defines the intended venue 
         * for the activity defined by a calendar component. Inspired 
         * by RFC 2445 sec 4.8.1.7 with the following reservations: the 
         * LANGUAGE parameter has been discarded. Please use xml:lang 
         * literals to express language. For the ALTREP parameter use 
         * the locationAltRep property. 
         */
        void addLocation( const QString& value );

        /**
         * Set property 'location'. Defines the intended venue for the 
         * activity defined by a calendar component. Inspired by RFC 2445 
         * sec 4.8.1.7 with the following reservations: the LANGUAGE 
         * parameter has been discarded. Please use xml:lang literals 
         * to express language. For the ALTREP parameter use the locationAltRep 
         * property. 
         */
        void setLocation( const QString& value );

        /**
         * \return The URI of the property 'location'. 
         */
        static QUrl locationUri();

        /**
         * Set property 'locationAltRep'. Alternate representation 
         * of the event or todo location. Introduced to cover the ALTREP 
         * parameter of the LOCATION property. See documentation of ncal:location 
         * for details. 
         */
        void setLocationAltReps( const QList<Resource>& value );

        /**
         * Add a value to property 'locationAltRep'. Alternate representation 
         * of the event or todo location. Introduced to cover the ALTREP 
         * parameter of the LOCATION property. See documentation of ncal:location 
         * for details. 
         */
        void addLocationAltRep( const Resource& value );

        /**
         * \return The URI of the property 'locationAltRep'. 
         */
        static QUrl locationAltRepUri();

        /**
         * Set property 'Alarm'. Links an event or a todo with a DataObject 
         * that can be interpreted as an alarm. This property has no direct 
         * equivalent in the RFC 2445. It has been provided to express this 
         * relation. 
         */
        void setAlarms( const QList<CalendarDataObject>& value );

        /**
         * Add a value to property 'Alarm'. Links an event or a todo with 
         * a DataObject that can be interpreted as an alarm. This property 
         * has no direct equivalent in the RFC 2445. It has been provided 
         * to express this relation. 
         */
        void addAlarm( const CalendarDataObject& value );

        /**
         * \return The URI of the property 'Alarm'. 
         */
        static QUrl alarmUri();

        /**
         * Set property 'resourcesAltRep'. Alternate representation 
         * of the resources needed for an event or todo. Introduced to cover 
         * the ALTREP parameter of the resources property. See documentation 
         * for ncal:resources for details. 
         */
        void setResourcesAltReps( const QList<Resource>& value );

        /**
         * Add a value to property 'resourcesAltRep'. Alternate representation 
         * of the resources needed for an event or todo. Introduced to cover 
         * the ALTREP parameter of the resources property. See documentation 
         * for ncal:resources for details. 
         */
        void addResourcesAltRep( const Resource& value );

        /**
         * \return The URI of the property 'resourcesAltRep'. 
         */
        static QUrl resourcesAltRepUri();



    protected:
        UnionOfEventTodo( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
